//Ethan Alexander Shulman 2024

//generate path finding lut's for map points
function GeneratePathFinding() {
	var numPts = mapPoints.length;
	for (var i = 0; i < numPts; i++) {
		//allocate luts
		var pt = mapPoints[i],
			find = new Array(numPts),
			lens = new Array(numPts),
			skip = new Array(numPts);
		lens.fill(1e16);
		skip.fill(false);
		
		pt.findPath = find;
		pt.pfLengths = lens;
		pt.pfSkip = skip;
		
		//init neighbour paths
		var local = pt.paths,
			nebors = pt.connections,
			nLocal = local.length;
		for (var l = 0; l < nLocal; l++) {
			var pid = nebors[l].pointId;
			skip[pid] = true;
			find[pid] = l;
			lens[pid] = local[l].distance;
		}
	}
	
	//connect shortest paths until we don't find anymore
	var numPtsM1 = numPts-1,
		foundNew = true;
	while (foundNew) {
		foundNew = false;
		for (var i = 0; i < numPtsM1; i++) {
			var pt = mapPoints[i],
				nebors = pt.connections,
				nLocal = nebors.length,
				find = pt.findPath,
				lens = pt.pfLengths,
				skip = pt.pfSkip;
			
			for (var c = i+1; c < numPts; c++) {
				if (skip[c]) continue;//skip neighbours
				
				var minLen = 1e16, minL = 0;
				for (var l = 0; l < nLocal; l++) {
					var nb = nebors[l],
						len = nb.pfLengths[c];
					if (len >= 1e16) continue;//no path to connection, skip
					
					len += lens[nb.pointId];
					if (len < minLen) {
						minLen = len;
						minL = l;
					}
				}
				
				if (minLen < 1e16 && minLen < lens[c]) {
					var cPt = mapPoints[c];
					lens[c] = minLen;
					cPt.pfLengths[i] = minLen;
					find[c] = minL;
					cPt.findPath[i] = cPt.findPath[nebors[minL].pointId];
					foundNew = true;
				}
			}
		}
	}
	
	//free unused arrays and set self path lengths to 0
	for (var i = 0; i < numPts; i++) {
		var pt = mapPoints[i];
		pt.pfLengths[i] = 0;
		pt.pfSkip = null;
	}
}
