//Ethan Alexander Shulman 2024

var ubuf = new Uint32Array(8), abuf = [], returnY = 0;


if (NWJS_VERSION) {
	var sele = document.createElement("script");
	sele.src = "NWJS.js";
	document.head.appendChild(sele);
}


//input seed in ubuf[0] and transforms into random uint32 output in ubuf[0]
function PRNGHash() {
	ubuf[0] ^= Math.imul(ubuf[0],2425714368) ^ (ubuf[0]>>>1);
	ubuf[0] ^= Math.imul(ubuf[0],2893397823) ^ (ubuf[0]>>>10);
	ubuf[0] ^= Math.imul(ubuf[0],2058600894) ^ (ubuf[0]>>>19);
}

/**@constructor*/
function PRNG(seed) {
	this.seed = (seed?seed:0);
}
PRNG.prototype.Uint32 = function() {
	ubuf[0] = this.seed++;
	if (this.seed > 0xFFFFFFFF) this.seed = 0;
	PRNGHash();
	return ubuf[0];
}
PRNG.prototype.Int = function(minv,maxv) {
	ubuf[0] = this.seed++;
	if (this.seed > 0xFFFFFFFF) this.seed = 0;
	PRNGHash();
	return ubuf[0]%(maxv-minv) + minv;
}
PRNG.prototype.Float = function(minv,maxv) {
	ubuf[0] = this.seed++;
	if (this.seed > 0xFFFFFFFF) this.seed = 0;
	PRNGHash();
	return (ubuf[0]/0xFFFFFFFF)*(maxv-minv)+minv;
}


/*Function: Array.prototype.fastRemove
Quickly remove a single element at index i, but breaks order of array by moving end element to removed element.
Does not perform error checking, if index is out of bounds undefined behaviour will occur.

Parameters:
*int* i - Index of element to remove in array.*/
Array.prototype.fastRemove = function(i) {
	var ei = this.length-1;
	if (i !== ei) this[i] = this[ei];
	this.length = ei;
}


/*Class: ObjectPool
Object pool, inherits from Array.

Constructor: ObjectPool
Constructs new ObjectPool.

Parameters:
*function* objClass - Object class constructor.*/
/**@constructor*/
function ObjectPool(objClass) {
	Array.call(this);
	this.objectClass = objClass;
}
ObjectPool.prototype = Object.create(Array.prototype);
/*Function: Get
Get object from pool.

Returns:
*Object**/
ObjectPool.prototype.Get = function() {
	var l = this.length;
	if (l) {
		l--;
		var o = this[l];
		this.length = l;
		return o;
	} else {
		return new this.objectClass();
	}
}
/*Function: Return
Return object to pool.

Paramters:
*Object* o*/
ObjectPool.prototype.Return = function(o) {
	this.push(o);
}
