//Ethan Alexander Shulman 2024

var inTutorial = false,
tutorialIncrement = false,
tutorialProgress = 0;



//start tutorial game
function LaunchTutorial() {
	tutorialProgress = 0;
	tutorialIncrement = false;
	inTutorial = true;
	unpaused = false;
	tutorialTxt.textContent = "Welcome to War of Pixels. "+
		(usingTouchInput ? "Touch with 2 fingers" : 
							"Left click")+" and drag to move the camera.";
							
	LaunchGame(0, 0, [[0,1,0]], 0);
	
	var epx = activeFactions[1].pixels,
		delCount = INITIAL_PIXEL_COUNT-14;
	for (var k = 0; k < delCount; k++) {
		epx[k].life = 0;
		deadPixels.push(epx[k]);
	}
	for (var k = 0; k < 5; k++) playerFaction.Spawn(mapFactionSpawns[0]);
	cameraX = 1024;
	cameraY = 1024;
	cameraZoom = 400;
	UpdateTutorial();
}



function UpdateTutorial() {
	if (tutorialIncrement) {
		EV(tutorialDone,false);
		tutorialIncrement = false;
		tutorialProgress++;
		
		//tutorial steps
		switch (tutorialProgress) {
		case 1:
			cameraZoom = 400;
			tutorialTxt.textContent =
			(usingTouchInput ? "Touch with 2 fingers, bring them together to zoom out and move them apart to zoom in." :
								"Scroll the mouse wheel to zoom in and out, or use '1' key to zoom in and '2' key to zoom out.");
			break;
			
		case 2:
			var tpt = mapFactionSpawns[0];
			cameraX = tpt.x;
			cameraY = tpt.y-50;
			cameraZoom = 256;
			tutorialTxt.textContent = "These are your Pixels, select them by "+
									(usingTouchInput ? "touching with 1 finger and dragging" : "right clicking and dragging")+
										". A selection box will appear to visualize your selection area.";
			break;
			
		case 3:
			tpt = mapPoints[4];
			cameraX = tpt.x;
			cameraY = tpt.y-25;
			cameraZoom = 128;
			tutorialTxt.textContent = "This is a empty Pixel Mine, "+(usingTouchInput ? "tap" : "right click")+
										" the Mine to move your selected Pixels to it.";
			break;
			
		case 4:
			cameraZoom = 256;
			tutorialTxt.textContent = "Continue moving Pixels into the Mine until it is filled up to the white border. "+
									"Once a Mine is filled it will spawn more Pixels, investing in Mines is how you grow stronger.";
			break;
			
		case 5:
			tpt = mapPoints[11];
			cameraX = tpt.x;
			cameraY = tpt.y-50;
			cameraZoom = 256;
			tutorialTxt.textContent = "Here are the enemy Pixels, select and move your Pixels to initiate an attack.";
			break;
			
		case 6:
			tutorialTxt.textContent = "You have completed the tutorial!";
			break;
			
		case 7:
			inTutorial = false;
			EV(tutorialPanel, false);
			QuitGame();
			break;
		}
		
	} else {
		//update tutorial step objectives
		switch (tutorialProgress) {
		case 0:
			if (Math.abs(cameraX-1024) > 5 || Math.abs(cameraY-1024) > 5) tutorialIncrement = true;
			break;
			
		case 1:
			if (Math.abs(cameraZoom-400) > 5) unpaused = tutorialIncrement = true;
			break;
		
		case 2:
			if (selectedPixels.length > 0) tutorialIncrement = true;
			break;
			
		case 3:
			var ppx = playerFaction.pixels;
			for (var i = 0; i < ppx.length; i++) {
				if (ppx[i].travelPoint) {
					tutorialIncrement = true;
					break;
				}
			}
			break;
			
		case 4:
			if (mapPoints[4].mineFaction === playerFactionId) tutorialIncrement = true;
			break;
			
		case 5:
			if (activeFactions[1].pixels.length < 4) tutorialIncrement = true;
			break;
			
		case 6:
			tutorialIncrement = true;
			break;
		}
		
		if (tutorialIncrement) {
			EV(tutorialDone,true);
		}
	}
	
	if (inTutorial) setTimeout(UpdateTutorial,3000);
}
